#pragma once

#include "mqtt_wrapper.h"
#include <map>

namespace offcn
{
	class CmdProcesserClient : public CmdObserver
	{
	public:
		CmdProcesserClient();
		~CmdProcesserClient();

	public:
		void SetLocalID(std::string id);
		bool Connect();
		bool SubscribeTopic();
		/**
		 *	@param	type	offer/answer
		 */
		bool SendLocalCandidate(std::string tid, std::string type, std::string candidate);

	public:
		/**
		 * CmdObserver
		 */
		virtual void OnServerConnectSuccess();
		virtual void OnServerConnectFailure();
		virtual void OnServerSubscribeSuccess();
		virtual void OnServerSubscribeFailure();
		virtual void OnServerMessageArrived(std::string topic, std::string message);

	private:
		MqttWrapper	*mqtt_wrapper_;
	private:
		std::map<std::string, std::string> publisher_list_;
		std::map<std::string, std::string> subscriber_list_;
	private:
		std::string local_id_;
	};
}